<?php

namespace App\Http\Requests\Admin;

use App\Models\Attribute;
use App\Models\Category;
use App\Enums\ProductCostStatusEnum;
use App\Models\CategoryAttribute;
use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;

class ProductRequest extends FormRequest
{

    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        if (! Auth::check()) {
            return false;
        }
        if(in_array(Auth::user()->role, ['super_admin', 'admin', 'sub_admin']))
        {
            return true;
        }

        if(Auth::user()->hasModule('products'))
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $rules=[
            'image'=>'required',
            'code'=> [
                "required",
                "max:50",
                Rule::unique('products')->ignore($this->product? $this->product->id : 0, 'id')
            ],
            'count'=>'required|numeric|min:0',
            'category_id'=>'required|exists:categories,id',
            'model_id'=>'sometimes|exists:categories,id',
            'brand_id'=>'sometimes|nullable|exists:categories,id',
            'cost'=>'required|numeric|max_digits:10|min:1',
            'cost_discount'=>'sometimes|nullable|numeric|max_digits:10|min:1|lt:cost',
        ];
        if(request('category_id'))
        {
            $models = Category::where('category_id',request('category_id'))->count();
            if($models > 0)
            {
                $rules['model_id'] = 'required|exists:categories,id';
            }
        }

        foreach (languages() as $lang) {
            $lang_rules=[
                'name_'.$lang->local=> 'required|max:55',
                'details_'.$lang->local=> 'required',
                'description_'.$lang->local=> 'required',
            ];
            $rules= array_merge($rules, $lang_rules);
        }
        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {

        $field = metaFields('products');
        $attributes=[
            'image' => __('products.image'),
            'category_id' => __('products.category_id'),
            'model_id' => __('products.model_id'),
            'code' => __('products.code'),
            'count' => __('products.count'),
            'cost_discount' => __('products.cost_discount'),
            'cost' => __('products.cost'),
            'brand_id' => __('products.brand_id'),
        ];

        foreach (languages() as $lang) {
            $lang_attributes=[
                'name_'.$lang->local=>  __('products.name') .' '.$lang->local,
                'description_'.$lang->local=>  __('products.description') .' '.$lang->local,
                'details_'.$lang->local=>  __('products.details') .' '.$lang->local,
            ];
            $attributes= array_merge($attributes, $lang_attributes);
        }

        return $attributes;
    }


    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests

        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
